'use strict';










var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);


var _scrollList = require('./lib/scrollList');var _scrollList2 = _interopRequireDefault(_scrollList);
var _terminalUtils = require('./lib/terminalUtils');
var _Prompt = require('./lib/Prompt');var _Prompt2 = _interopRequireDefault(_Prompt);
var _formatTestNameByPattern = require('./lib/formatTestNameByPattern');var _formatTestNameByPattern2 = _interopRequireDefault(_formatTestNameByPattern);
var _patternModeHelpers = require('./lib/patternModeHelpers');








var _PatternPrompt = require('./PatternPrompt');var _PatternPrompt2 = _interopRequireDefault(_PatternPrompt);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };} /**
                                                                                                                                                                                                            * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                                                                                                                                                                            *
                                                                                                                                                                                                            * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                            * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                                            * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                                            *
                                                                                                                                                                                                            * 
                                                                                                                                                                                                            */module.exports = class TestNamePatternPrompt extends _PatternPrompt2.default {constructor(pipe, prompt) {super(pipe, prompt);this._entityName = 'tests';this._cachedTestResults = [];
  }

  _onChange(pattern, options) {
    super._onChange(pattern, options);
    this._printTypeahead(pattern, options);
  }

  _printTypeahead(pattern, options) {
    const matchedTests = this._getMatchedTests(pattern);
    const total = matchedTests.length;
    const pipe = this._pipe;
    const prompt = this._prompt;

    (0, _patternModeHelpers.printPatternCaret)(pattern, pipe);

    if (pattern) {
      (0, _patternModeHelpers.printPatternMatches)(
      total,
      'test',
      pipe,
      ` from ${_chalk2.default.yellow('cached')} test suites`);


      const width = (0, _terminalUtils.getTerminalWidth)();var _scroll =
      (0, _scrollList2.default)(total, options);const start = _scroll.start,end = _scroll.end,index = _scroll.index;

      prompt.setTypeaheadLength(total);

      matchedTests.
      slice(start, end).
      map(name => (0, _formatTestNameByPattern2.default)(name, pattern, width - 4)).
      map((item, i) => (0, _patternModeHelpers.formatTypeaheadSelection)(item, i, index, prompt)).
      forEach(item => (0, _patternModeHelpers.printTypeaheadItem)(item, pipe));

      if (total > end) {
        (0, _patternModeHelpers.printMore)('test', pipe, total - end);
      }
    } else {
      (0, _patternModeHelpers.printStartTyping)('test name', pipe);
    }

    (0, _patternModeHelpers.printRestoredPatternCaret)(pattern, this._currentUsageRows, pipe);
  }

  _getMatchedTests(pattern) {
    let regex;

    try {
      regex = new RegExp(pattern, 'i');
    } catch (e) {
      return [];
    }

    const matchedTests = [];

    this._cachedTestResults.forEach((_ref) => {let testResults = _ref.testResults;return (
        testResults.forEach((_ref2) => {let title = _ref2.title;
          if (regex.test(title)) {
            matchedTests.push(title);
          }
        }));});


    return matchedTests;
  }

  updateCachedTestResults() {let testResults = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    this._cachedTestResults = testResults;
  }};