'use strict';















var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);
var _stringLength = require('string-length');var _stringLength2 = _interopRequireDefault(_stringLength);
var _scrollList = require('./lib/scrollList');var _scrollList2 = _interopRequireDefault(_scrollList);
var _terminalUtils = require('./lib/terminalUtils');
var _highlight = require('./lib/highlight');var _highlight2 = _interopRequireDefault(_highlight);
var _utils = require('./reporters/utils');
var _Prompt = require('./lib/Prompt');var _Prompt2 = _interopRequireDefault(_Prompt);
var _patternModeHelpers = require('./lib/patternModeHelpers');








var _PatternPrompt = require('./PatternPrompt');var _PatternPrompt2 = _interopRequireDefault(_PatternPrompt);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };} // eslint-disable-next-line import/default






module.exports = class TestPathPatternPrompt extends _PatternPrompt2.default {


  constructor(pipe, prompt) {
    super(pipe, prompt);
    this._entityName = 'filenames';
  }

  _onChange(pattern, options) {
    super._onChange(pattern, options);
    this._printTypeahead(pattern, options);
  }

  _printTypeahead(pattern, options) {
    const matchedTests = this._getMatchedTests(pattern);
    const total = matchedTests.length;
    const pipe = this._pipe;
    const prompt = this._prompt;

    (0, _patternModeHelpers.printPatternCaret)(pattern, pipe);

    if (pattern) {
      (0, _patternModeHelpers.printPatternMatches)(total, 'file', pipe);

      const prefix = `  ${_chalk2.default.dim('\u203A')} `;
      const padding = (0, _stringLength2.default)(prefix) + 2;
      const width = (0, _terminalUtils.getTerminalWidth)();var _scroll =
      (0, _scrollList2.default)(total, options);const start = _scroll.start,end = _scroll.end,index = _scroll.index;

      prompt.setTypeaheadLength(total);

      matchedTests.
      slice(start, end).
      map((_ref) => {let path = _ref.path,context = _ref.context;
        const filePath = (0, _utils.trimAndFormatPath)(
        padding,
        context.config,
        path,
        width);

        return (0, _highlight2.default)(path, filePath, pattern, context.config.rootDir);
      }).
      map((item, i) => (0, _patternModeHelpers.formatTypeaheadSelection)(item, i, index, prompt)).
      forEach(item => (0, _patternModeHelpers.printTypeaheadItem)(item, pipe));

      if (total > end) {
        (0, _patternModeHelpers.printMore)('file', pipe, total - end);
      }
    } else {
      (0, _patternModeHelpers.printStartTyping)('filename', pipe);
    }

    (0, _patternModeHelpers.printRestoredPatternCaret)(pattern, this._currentUsageRows, pipe);
  }

  _getMatchedTests(pattern) {
    let regex;

    try {
      regex = new RegExp(pattern, 'i');
    } catch (e) {}

    let tests = [];
    if (regex) {
      this._searchSources.forEach((_ref2) => {let searchSource = _ref2.searchSource,context = _ref2.context;
        tests = tests.concat(searchSource.findMatchingTests(pattern).tests);
      });
    }

    return tests;
  }

  updateSearchSources(searchSources) {
    this._searchSources = searchSources;
  }}; /**
       * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
       *
       * This source code is licensed under the BSD-style license found in the
       * LICENSE file in the root directory of this source tree. An additional grant
       * of patent rights can be found in the PATENTS file in the same directory.
       *
       * 
       */