'use strict';













var _ansiEscapes = require('ansi-escapes');var _ansiEscapes2 = _interopRequireDefault(_ansiEscapes);
var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);
var _jestRegexUtil = require('jest-regex-util');
var _jestHasteMap = require('jest-haste-map');var _jestHasteMap2 = _interopRequireDefault(_jestHasteMap);
var _isCi = require('is-ci');var _isCi2 = _interopRequireDefault(_isCi);
var _isValidPath = require('./lib/isValidPath');var _isValidPath2 = _interopRequireDefault(_isValidPath);
var _preRunMessage = require('./preRunMessage');var _preRunMessage2 = _interopRequireDefault(_preRunMessage);
var _createContext = require('./lib/createContext');var _createContext2 = _interopRequireDefault(_createContext);
var _runJest = require('./runJest');var _runJest2 = _interopRequireDefault(_runJest);
var _updateArgv = require('./lib/updateArgv');var _updateArgv2 = _interopRequireDefault(_updateArgv);
var _SearchSource = require('./SearchSource');var _SearchSource2 = _interopRequireDefault(_SearchSource);
var _TestWatcher = require('./TestWatcher');var _TestWatcher2 = _interopRequireDefault(_TestWatcher);
var _Prompt = require('./lib/Prompt');var _Prompt2 = _interopRequireDefault(_Prompt);
var _TestPathPatternPrompt = require('./TestPathPatternPrompt');var _TestPathPatternPrompt2 = _interopRequireDefault(_TestPathPatternPrompt);
var _TestNamePatternPrompt = require('./TestNamePatternPrompt');var _TestNamePatternPrompt2 = _interopRequireDefault(_TestNamePatternPrompt);
var _constants = require('./constants');function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

const isInteractive = process.stdout.isTTY && !_isCi2.default; /**
                                                                * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                                *
                                                                * This source code is licensed under the BSD-style license found in the
                                                                * LICENSE file in the root directory of this source tree. An additional grant
                                                                * of patent rights can be found in the PATENTS file in the same directory.
                                                                *
                                                                * 
                                                                */let hasExitListener = false;const watch = function (initialGlobalConfig, contexts, argv, pipe, hasteMapInstances)

{let stdin = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : process.stdin;
  (0, _updateArgv2.default)(argv, argv.watch ? 'watch' : 'watchAll', {
    testNamePattern: argv.testNamePattern,
    testPathPattern: argv.testPathPattern || (argv._ || []).join('|') });


  const prompt = new _Prompt2.default();
  const testPathPatternPrompt = new _TestPathPatternPrompt2.default(pipe, prompt);
  const testNamePatternPrompt = new _TestNamePatternPrompt2.default(pipe, prompt);
  let searchSources = contexts.map(context => ({
    context,
    searchSource: new _SearchSource2.default(context) }));

  let hasSnapshotFailure = false;
  let isRunning = false;
  let testWatcher;
  let shouldDisplayWatchUsage = true;
  let isWatchUsageDisplayed = false;

  testPathPatternPrompt.updateSearchSources(searchSources);

  hasteMapInstances.forEach((hasteMapInstance, index) => {
    hasteMapInstance.on('change', (_ref) => {let eventsQueue = _ref.eventsQueue,hasteFS = _ref.hasteFS,moduleMap = _ref.moduleMap;
      const validPaths = eventsQueue.filter((_ref2) => {let filePath = _ref2.filePath;
        return (0, _isValidPath2.default)(
        initialGlobalConfig,
        contexts[index].config,
        filePath);

      });

      if (validPaths.length) {
        const context = contexts[index] = (0, _createContext2.default)(
        contexts[index].config,
        {
          hasteFS,
          moduleMap });


        prompt.abort();
        searchSources = searchSources.slice();
        searchSources[index] = {
          context,
          searchSource: new _SearchSource2.default(context) };

        testPathPatternPrompt.updateSearchSources(searchSources);
        startRun();
      }
    });
  });

  if (!hasExitListener) {
    hasExitListener = true;
    process.on('exit', () => {
      if (prompt.isEntering()) {
        pipe.write(_ansiEscapes2.default.cursorDown());
        pipe.write(_ansiEscapes2.default.eraseDown);
      }
    });
  }

  const startRun = function () {let overrideConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    if (isRunning) {
      return null;
    }

    testWatcher = new _TestWatcher2.default({ isWatchMode: true });
    isInteractive && pipe.write(_constants.CLEAR);
    _preRunMessage2.default.print(pipe);
    isRunning = true;
    const globalConfig = Object.freeze(
    Object.assign({}, initialGlobalConfig, overrideConfig, {
      testNamePattern: argv.testNamePattern,
      testPathPattern: argv.testPathPattern }));


    return (0, _runJest2.default)(
    // $FlowFixMe
    globalConfig,
    contexts,
    argv,
    pipe,
    testWatcher,
    startRun,
    results => {
      isRunning = false;
      hasSnapshotFailure = !!results.snapshot.failure;
      // Create a new testWatcher instance so that re-runs won't be blocked.
      // The old instance that was passed to Jest will still be interrupted
      // and prevent test runs from the previous run.
      testWatcher = new _TestWatcher2.default({ isWatchMode: true });
      if (shouldDisplayWatchUsage) {
        pipe.write(usage(argv, hasSnapshotFailure));
        shouldDisplayWatchUsage = false; // hide Watch Usage after first run
        isWatchUsageDisplayed = true;
      } else {
        pipe.write(showToggleUsagePrompt());
        shouldDisplayWatchUsage = false;
        isWatchUsageDisplayed = false;
      }

      testNamePatternPrompt.updateCachedTestResults(results.testResults);
    }).
    catch(error => console.error(_chalk2.default.red(error.stack)));
  };

  const onKeypress = key => {
    if (key === _constants.KEYS.CONTROL_C || key === _constants.KEYS.CONTROL_D) {
      process.exit(0);
      return;
    }

    if (prompt.isEntering()) {
      prompt.put(key);
      return;
    }

    // Abort test run
    if (
    isRunning &&
    testWatcher &&
    [_constants.KEYS.Q, _constants.KEYS.ENTER, _constants.KEYS.A, _constants.KEYS.O, _constants.KEYS.P, _constants.KEYS.T].indexOf(key) !== -1)
    {
      testWatcher.setState({ interrupted: true });
      return;
    }

    switch (key) {
      case _constants.KEYS.Q:
        process.exit(0);
        return;
      case _constants.KEYS.ENTER:
        startRun();
        break;
      case _constants.KEYS.U:
        startRun({ updateSnapshot: 'all' });
        break;
      case _constants.KEYS.A:
        (0, _updateArgv2.default)(argv, 'watchAll', {
          testNamePattern: '',
          testPathPattern: '' });

        startRun();
        break;
      case _constants.KEYS.C:
        (0, _updateArgv2.default)(argv, 'watch', {
          testNamePattern: '',
          testPathPattern: '' });

        startRun();
        break;
      case _constants.KEYS.O:
        (0, _updateArgv2.default)(argv, 'watch', {
          testNamePattern: '',
          testPathPattern: '' });

        startRun();
        break;
      case _constants.KEYS.P:
        testPathPatternPrompt.run(
        testPathPattern => {
          (0, _updateArgv2.default)(argv, 'watch', {
            testNamePattern: '',
            testPathPattern: (0, _jestRegexUtil.replacePathSepForRegex)(testPathPattern) });


          startRun();
        },
        onCancelPatternPrompt,
        { header: activeFilters(argv) });

        break;
      case _constants.KEYS.T:
        testNamePatternPrompt.run(
        testNamePattern => {
          (0, _updateArgv2.default)(argv, 'watch', {
            testNamePattern,
            testPathPattern: argv.testPathPattern });


          startRun();
        },
        onCancelPatternPrompt,
        { header: activeFilters(argv) });

        break;
      case _constants.KEYS.QUESTION_MARK:
        break;
      case _constants.KEYS.W:
        if (!shouldDisplayWatchUsage && !isWatchUsageDisplayed) {
          pipe.write(_ansiEscapes2.default.cursorUp());
          pipe.write(_ansiEscapes2.default.eraseDown);
          pipe.write(usage(argv, hasSnapshotFailure));
          isWatchUsageDisplayed = true;
          shouldDisplayWatchUsage = false;
        }
        break;}

  };

  const onCancelPatternPrompt = () => {
    pipe.write(_ansiEscapes2.default.cursorHide);
    pipe.write(_ansiEscapes2.default.clearScreen);
    pipe.write(usage(argv, hasSnapshotFailure));
    pipe.write(_ansiEscapes2.default.cursorShow);
  };

  if (typeof stdin.setRawMode === 'function') {
    stdin.setRawMode(true);
    stdin.resume();
    stdin.setEncoding('hex');
    stdin.on('data', onKeypress);
  }

  startRun();
  return Promise.resolve();
};

const activeFilters = function (argv) {let delimiter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '\n';const
  testNamePattern = argv.testNamePattern,testPathPattern = argv.testPathPattern;
  if (testNamePattern || testPathPattern) {
    const filters = [
    testPathPattern ?
    _chalk2.default.dim('filename ') + _chalk2.default.yellow('/' + testPathPattern + '/') :
    null,
    testNamePattern ?
    _chalk2.default.dim('test name ') + _chalk2.default.yellow('/' + testNamePattern + '/') :
    null].

    filter(f => !!f).
    join(', ');

    const messages = ['\n' + _chalk2.default.bold('Active Filters: ') + filters];

    return messages.filter(message => !!message).join(delimiter);
  }

  return '';
};

const usage = function (argv, snapshotFailure) {let delimiter = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '\n';
  const messages = [
  activeFilters(argv),
  argv.testPathPattern || argv.testNamePattern ?
  _chalk2.default.dim(' \u203A Press ') + 'c' + _chalk2.default.dim(' to clear filters.') :
  null,
  '\n' + _chalk2.default.bold('Watch Usage'),
  argv.watch ?
  _chalk2.default.dim(' \u203A Press ') + 'a' + _chalk2.default.dim(' to run all tests.') :
  null,
  (argv.watchAll || argv.testPathPattern || argv.testNamePattern) &&
  !argv.noSCM ?
  _chalk2.default.dim(' \u203A Press ') +
  'o' +
  _chalk2.default.dim(' to only run tests related to changed files.') :
  null,
  snapshotFailure ?
  _chalk2.default.dim(' \u203A Press ') +
  'u' +
  _chalk2.default.dim(' to update failing snapshots.') :
  null,
  _chalk2.default.dim(' \u203A Press ') +
  'p' +
  _chalk2.default.dim(' to filter by a filename regex pattern.'),
  _chalk2.default.dim(' \u203A Press ') +
  't' +
  _chalk2.default.dim(' to filter by a test name regex pattern.'),
  _chalk2.default.dim(' \u203A Press ') + 'q' + _chalk2.default.dim(' to quit watch mode.'),
  _chalk2.default.dim(' \u203A Press ') +
  'Enter' +
  _chalk2.default.dim(' to trigger a test run.')];


  return messages.filter(message => !!message).join(delimiter) + '\n';
};

const showToggleUsagePrompt = () =>
'\n' +
_chalk2.default.bold('Watch Usage: ') +
_chalk2.default.dim('Press ') +
'w' +
_chalk2.default.dim(' to show more.');

module.exports = watch;